package test.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.Statement;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class InsertTest extends HttpServlet {

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		//クライアントに出力する準備
		resp.setContentType("text/html; charset=utf-8");
		PrintWriter pw = resp.getWriter();

		//送信されたデータを取得
		String userid = req.getParameter("userid");
		String username = req.getParameter("username");
		String password = req.getParameter("password");
		String namae = req.getParameter("namae");

		//受信したデータをUTF-8に変換
		userid = new String(userid.getBytes("8859_1"), "UTF-8");
		username = new String(username.getBytes("8859_1"), "UTF-8");
		password = new String(password.getBytes("8859_1"), "UTF-8");
		namae = new String(namae.getBytes("8859_1"), "UTF-8");

		String message = null;
		Connection con = null;

		try{
			//JDBCドライバクラスの指定
			String drivername = "com.mysql.jdbc.Driver";

			//データベースを指定
			String url = "jdbc:mysql://localhost:3306/books?characterEncoding=utf8";

			//ユーザー名
			String user = "root";

			//パスワード
			String pass = "";

			//指定したドライバクラスを読み込み
			Class.forName(drivername);

			//データベースに接続
			con = DriverManager.getConnection(url, user, pass);

			//パラメータ化されたSQL文を生成
			StringBuilder sql = new StringBuilder();
			sql.append("INSERT INTO ");
			sql.append(" users ");
			sql.append("VALUES ");
			sql.append("(?,?,?,?)");

			//PreparedStatementオブジェクトを生成
			PreparedStatement pst = con.prepareStatement(sql.toString());

			//パラメータをセット
			pst.setString(1, userid);
			pst.setString(2, username);
			pst.setString(3, password);
			pst.setString(4, namae);

			//SQL文を実行
			int ret = pst.executeUpdate();

			//Statementオブジェクトを切断
			pst.close();

			if(ret != 0){
				message = "登録しました。";
			}else{
				message = "登録に失敗しました。";
			}
		}catch(Exception e){
			//エラーメッセージをセット
			message = "データベースに接続できませんでした。";
		}finally{
			try{
				//データベースに接続されていれば切断する
				if(con != null){
					con	.close();
				}
			}catch(Exception e){
				message = "エラーが発生しました。";
			}
		}

		//クライアントにHTMLタグを書き出し
		pw.println("<html>");
		pw.println("<head>");
		pw.println("<title>データベースに接続する</title>");
		pw.println("</head>");
		pw.println("<body>");
		pw.println(message);
		pw.println("<br>");
		pw.println("<a href=\"/WebApp/SelectTest.jsp\">一覧へ</a>");
		pw.println("</body>");
		pw.println("</html>");
	}

}
